--
-- Holland_Map_V3001
--
-- @author  John Dasselaar
-- @date  09/06/14
--
-- Copyright (C) GIANTS Software GmbH, Confidential, All Rights Reserved.

Holland_Map_V3001 = {}

local Holland_Map_V3001_mt = Class(Holland_Map_V3001, Mission00);


function Holland_Map_V3001:new(baseDirectory, customMt)
    local mt = customMt;
    if mt == nil then
        mt = Holland_Map_V3001_mt;
    end;
    local self = Holland_Map_V3001:superClass():new(baseDirectory, mt);

--    self.playerStartX = 39;
--    self.playerStartY = 0.1;
--    self.playerStartZ = -330;
--    self.playerRotX = 0;
--    self.playerRotY = Utils.degToRad(90);

    return self;
end;

function Holland_Map_V3001:delete()
    Holland_Map_V3001:superClass().delete(self);
end;

function Holland_Map_V3001:load()
    self:startLoadingTask();

    self.environment = Environment:new(Utils.getFilename("$data/sky/sky_day_night.i3d", self.baseDirectory), true, 8, true, true);

    self.helpIconsBase = nil;
    self.collectableHorseshoesObject = nil;
    self.fieldDefinitionBase = nil;
    self.vehicleShopBase = nil;

    self:loadMap(Utils.getFilename("map02.i3d", self.baseDirectory), true, self.loadMap01Finished, self);
end;

function Holland_Map_V3001:loadMap01Finished(node, arguments)

	self.terrainDetailAngleNumChannels = 8; -- durch die gewnschte Anzahl Channels ersetzen
	self.terrainDetailAngleMaxValue = bitShiftLeft(1, self.terrainDetailAngleNumChannels) - 1;


    self:loadMapXMLFile(Utils.getFilename("Holland_Map_V3001.xml", self.baseDirectory));

    self.missionPDA:loadMap(Utils.getFilename("pda_map.png", self.baseDirectory), 2048, 2048);

    g_inGameMenu:setMapViewsMap(Utils.getFilename("pda_map.png", self.baseDirectory));

    local iconSize = self.missionPDA.pdaMapWidth / 15;

    -- ATMs
    self.missionPDA:createMapHotspot("Bank", Utils.getFilename("$dataS2/missions/hud_pda_spot_bank.png", self.baseDirectory), 419, 163, iconSize, iconSize * (4 / 3), false, false, false, 0, true);
	
    -- Vehicle Shop
    self.missionPDA:createMapHotspot("Shop", Utils.getFilename("$dataS2/missions/hud_pda_spot_shop.png", self.baseDirectory), 431, 164, iconSize, iconSize * (4 / 3), false, false, false, 0, true);

    -- Phone Booths
    self.missionPDA:createMapHotspot("Phone", Utils.getFilename("$dataS2/missions/hud_pda_spot_phone.png", self.baseDirectory), 442, 178, iconSize, iconSize * (4 / 3), false, false, false, 0, true);

    -- livestock
    self.missionPDA:createMapHotspot("Cows", Utils.getFilename("$dataS2/missions/hud_pda_spot_cows.png", self.baseDirectory), 256, 655, iconSize, iconSize * (4 / 3), false, false, false, 0, true);
    self.missionPDA:createMapHotspot("Sheep", Utils.getFilename("$dataS2/missions/hud_pda_spot_sheep.png", self.baseDirectory), 178, 647, iconSize, iconSize * (4 / 3), false, false, false, 0, true);
    self.missionPDA:createMapHotspot("Chickens", Utils.getFilename("$dataS2/missions/hud_pda_spot_chickens.png", self.baseDirectory), 215, 527, iconSize, iconSize * (4 / 3), false, false, false, 0, true);

    Holland_Map_V3001:superClass().load(self);

    if not self.missionDynamicInfo.isMultiplayer then
        self:updateFoundHorseshoes();
        self:updateFoundHelpIcons();
        self:updateMeteoriteCrash();
        self:updateRainbow();
    else
        self:removeAllHorseshoes();
        self:removeAllHelpIcons();
    end;

    if g_isGamescomVersion then
        self:playerOwnsAllFields();
    end;

    self:finishLoadingTask();
end;

function Holland_Map_V3001:onStartMission()
    Holland_Map_V3001:superClass().onStartMission(self);
end;

function Holland_Map_V3001:mouseEvent(posX, posY, isDown, isUp, button)
    Holland_Map_V3001:superClass().mouseEvent(self, posX, posY, isDown, isUp, button);
end;

function Holland_Map_V3001:keyEvent(unicode, sym, modifier, isDown)
    Holland_Map_V3001:superClass().keyEvent(self, unicode, sym, modifier, isDown);
end;

function Holland_Map_V3001:update(dt)
    Holland_Map_V3001:superClass().update(self, dt);
end;

function Holland_Map_V3001:draw()
    Holland_Map_V3001:superClass().draw(self);
end;